Program TestHead; {Test a printer's print head}
Uses Crt,Printer;
Var
     GraphicsString: string;
     LinesPerRow: integer;
     LineLength: integer;
     Dots: integer;
     ch: char;
     i: integer;

Procedure PrintLine(HeadNo: byte);
Var
     i,j: integer;
     k: LongInt;
     Sections: byte;

Begin
     Write(Lst,'Pin ',HeadNo:2);
     Write(Lst,GraphicsString);
     Write(Lst,chr(LineLength mod 256),chr(LineLength div 256));
     k:=1 shl LongInt(HeadNo);
     Sections:=Dots div 8;
     For i:=1 to LineLength do
          For j:=Sections downto 1 do
               Write(Lst,Chr((k shr (Pred(j)*8)) and $ff));
     Write(Lst,'  ');
     if (HeadNo+1) mod LinesPerRow=0 then WriteLn(Lst,'')
End;

Procedure SelectPrinter;
Var
     Ptype: byte;

Begin
     WriteLn('Choose a printer type:  ');
     WriteLn;
     WriteLn('1:  Epson 24-pin');
     WriteLn('2:  Epson 8-pin');
     WriteLn;
     Write('Enter selection here:  ');
     Repeat
         Ptype:=Ord(ReadKey)
     Until Ptype in [ord('1'),ord('2')];
     WriteLn(chr(Ptype));
     Case Ptype-ord('0') of
          1:  Begin
               GraphicsString:=#27+'*'+#32;
               LineLength:=30;
               LinesPerRow:=6;
               Dots:=24
              End;
          2:  Begin
               GraphicsString:=#27+'*'+#0;
               LineLength:=30;
               LinesPerRow:=6;
               Dots:=8
              End
     End;
     WriteLn;
     WriteLn
End;

Begin
     ClrScr;
     SelectPrinter;
     Write('Press any key when printer is ready.');
     ch:=ReadKey;
     WriteLn(Lst,'');
     WriteLn(Lst,'                         Print Head Test Program Output');
     WriteLn(Lst,'                         ------------------------------');
     WriteLn(Lst,'');
     WriteLn(Lst,'');
     For i:=0 to Dots-1 do
     Begin
          PrintLine(i)
     End;
     WriteLn(Lst,'');
     WriteLn(Lst,'')
End.